# transfertAnnot

Tool used to tranfert annotation between different versions of assemblies.

## Prerequist
* Anaconda3

Easy way to have a clean environment for Python 3.5 and other tools/lib (seqtk, snakemake numpy pandas).

See instructions here: [http://docs.continuum.io/anaconda/install/linux/](http://docs.continuum.io/anaconda/install/linux/)

* GMAP

See here for installation: [http://research-pub.gene.com/gmap/](http://research-pub.gene.com/gmap/)

## Create virtual environment fo the pipeline

After anaconda is installed, we create an virtual environment with python3.5

```console
$ conda create --name iwgsc-tranfertAnnot.venv python=3.5 numpy pandas snakemake seqtk
```

Then we load the virtualenv we just created:

```console
conda activate iwgsc-tranfertAnnot.venv
```

## Installation

```
git clone git@forgemia.inra.fr:gdec-bioinfo/iwgsc/transfertannot.git
```

## Usage

The pipeline consists in a Snakemake reciep and the input files are indicated in a config file [config.yml](config.yaml).

For now, the pipeline requires:

* Current reference
   * GFF of annotation
   * FASTA of reference sequence
* New target reference sequence
   * FASTA of reference sequence
   * GMAP index 

### Running the pipeline with snakemake
The config file must contain the paths to the different files needed and also the type of feature we consider for the anchoring with GMAP.

For example here we store our input files inside a directory `input`.

Then we set the different parameters such as:

```makefile
annotation: 'input/IWGSC_v1.1.gff3'
genome: 'input/IWGSC_REFSEQV1.0_pseudomolecules.fasta'
gmapdb: 'IWGSC_refSeqV1-gmapv18-05-11'
gmapdbpath: '/path/to/banks/gmap/'

featuretype: 'gene'
```

We can check the pipeline by performing a dry run:

```console
snakemake -nr
```

We can retriev the grpahs of the pipeline with:

```console
snakemake --dag|dot -Tpdf > dag.pdf
snakemake --rulegraph|dot -Tpdf > rulegraph.pdf
```

Finally, we run the pipeline with

```
snakemake
```

Once the analysis is done, we can leave the virtual environment

```console
conda deactivate
```

